%option 8bit
%option noyywrap
%option nostdinit
%option yylineno
%option case-insensitive
%option full

%{
    #include <iostream>
    #include <string>
    using namespace std;
    int yylex();
    #include "parser.cpp"
%}


LETTER [a-zA-Z]
DIGIT [0-9]
%% // --------------------------------------------------------------------------
"("                                     {return OPEN;}
")"                                     {return CLOSE;}
"="                                     {return EQ;}
[\t\ \n]*                               {}
"//"[^\n]*                              {}
"\\"|"\xce\xbb"                         {return LAMBDA;}
\.                                      {return ENDLAMBDA;}
";"                                     {return SEMICOLON;}
{LETTER}({LETTER}|{DIGIT})*             {yylval.text = new string(yytext); return ID;}
{DIGIT}+                                {yylval.text = new string(yytext); return INT;}

.|\n                                    {cerr << "\n\nLEXICAL ERROR"
                                              << ": Unexpected character \""
                                              << yytext[0] << "\"\n";}
%% //---------------------------------------------------------------------------